unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Menus, ExtCtrls, ComCtrls, TeEngine, Series,
  TeeProcs, Chart, te, lgp, sd, clipbrd, DateUtils;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Button1: TButton;
    Button2: TButton;
    opRandomSample: TCheckBox;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    UpDown1: TUpDown;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Panel1: TPanel;
    GroupBox2: TGroupBox;
    sgTest: TStringGrid;
    Splitter1: TSplitter;
    GroupBox3: TGroupBox;
    memTest: TMemo;
    Label3: TLabel;
    Edit3: TEdit;
    UpDown3: TUpDown;
    Splitter2: TSplitter;
    chTest: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Label6: TLabel;
    Edit6: TEdit;
    btPlot: TButton;
    Button3: TButton;
    Edit4: TMenuItem;
    CopyData1: TMenuItem;
    CopyChart1: TMenuItem;
    CopyModel1: TMenuItem;
    PastData1: TMenuItem;
    N2: TMenuItem;
    PopupMenu1: TPopupMenu;
    Copy1: TMenuItem;
    Past1: TMenuItem;
    PopupMenu2: TPopupMenu;
    Copy2: TMenuItem;
    opIncrementalSearch: TCheckBox;
    Label4: TLabel;
    Edit5: TEdit;
    tb1: TTrackBar;
    Label5: TLabel;
    procedure About1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btPlotClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure CopyData1Click(Sender: TObject);
    procedure CopyModel1Click(Sender: TObject);
    procedure CopyChart1Click(Sender: TObject);
    procedure PastData1Click(Sender: TObject);
    procedure tb1Change(Sender: TObject);
  private
    { Private declarations }
    sample : TSampleData;
    stop : boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.About1Click(Sender: TObject);
begin
        ShowMessage('By: Amaury Carvalho (amaurycarvalho@hotmail.com)');
end;

procedure TForm1.Button2Click(Sender: TObject);
var pop, chromo, vars : integer;
    t, correctness : integer;
    value : double;
    lgp : TLGP;
    si : TTuringEvaluator;
    time, diff : TDateTime;
begin

        time := Now;

        try
                pop := StrToInt(Edit3.Text);
                chromo := StrToInt(Edit2.Text);
                vars := StrToInt(Edit1.Text);
        except
                pop := 100;
                chromo := 5;
                vars := 1;
        end;

        updown1.Enabled := false;
        updown2.Enabled := false;
        updown3.Enabled := false;
        oprandomsample.Enabled := false;
        open1.Enabled := false;
        save1.Enabled := false;
        PastData1.Enabled := false;
        past1.Enabled := false;
        opIncrementalSearch.Enabled := false;
        tb1.Enabled := false;

        button1.Enabled := false;
        button2.Enabled := false;
        button3.Enabled := true;

        lgp := TLGP.Create(chromo, pop, vars);

        sample.setMarginOfError(tb1.Position/100.0);
        lgp.incrementalSearch := opIncrementalSearch.Checked;
        lgp.setSample(sample);

        stop := false;
        si := nil;

        while not stop do
        begin

                lgp.Evaluate;

                lgp.Evolve;

                if si <> lgp.getIndividual(0) then
                begin
                    si := lgp.getIndividual(0);
                    correctness := 0;
                    chTest.Series[1].Clear;
                    for t := 0 to sample.rowCount - 1 do
                    begin
                            value := si.Evaluate(sample.getX(t));
                            if (sample.isApproximateY(t, value)) then
                                correctness := correctness + 1;
                            chTest.series[1].AddXY(sample.getX(t), value);
                    end;

                    memTest.Lines.Clear;
                    memTest.Lines.Add('// model correctness: ' + IntToStr(correctness) + ' of ' + IntToStr(sample.rowCount));
                    memTest.Lines.Add('// margin of error: ' + FloatToStrF(sample.getMarginOfError*100, ffFixed, 10, 2) + '%');
                    memTest.Lines.Add('// model clones: ' + IntToStr(lgp.bestClones) );
                    memTest.Lines.Add(si.getCodeText);
                    memTest.SelStart := 0;
                    memTest.SelLength := 0;

                    if (correctness = sample.rowCount) then
                        stop := true;
                end;

                diff := (Now - Time);
                Edit6.Text := IntToStr(lgp.generationCount);
                Edit5.Text := IntToStr(hourOf(diff)) + 'h' + IntToStr(minuteOf(diff)) + 'm' + IntToStr(secondOf(diff)) + 's';

                application.ProcessMessages;
        end;

        lgp.Free;

        updown1.Enabled := true;
        updown2.Enabled := true;
        updown3.Enabled := true;
        oprandomsample.Enabled := true;
        open1.Enabled := true;
        save1.Enabled := true;
        PastData1.Enabled := true;
        past1.Enabled := true;
        opIncrementalSearch.Enabled := true;
        tb1.Enabled := true;

        button1.Enabled := true;
        button2.Enabled := true;
        button3.Enabled := false;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin

        if sample.rowCount <> 100 then
                sample.Resize(100);

        if opRandomSample.Checked then
                sample.setRandom
        else
                sample.setRandomSin;

        btPlotClick(Sender);
end;

procedure TForm1.btPlotClick(Sender: TObject);
var i : integer;
begin

        sgTest.RowCount := sample.rowCount+1;

        chTest.Series[0].Clear;
        chTest.Series[1].Clear;

        for i := 0 to sample.rowCount - 1 do
        begin
                sgTest.Cells[0, i+1] := IntToStr(i+1);
                sgTest.Cells[1, i+1] := FloatToStrF(sample.getX(i), ffFixed, 15, 6);
                sgTest.Cells[2, i+1] := FloatToStrF(sample.getY(i), ffFixed, 15, 6);
                chTest.Series[0].AddXY(sample.getX(i), sample.getY(i));
        end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
        randomize;

        sgTest.cells[1, 0] := 'x';
        sgTest.cells[2, 0] := 'y';

        sample := TSampleData.Create(0);
        
        Button1Click(Sender);

end;

procedure TForm1.Button3Click(Sender: TObject);
begin

        stop := true;
        
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin

        sample.Free;
        
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
        if opendialog1.Execute then
        begin
                sample.LoadFromFile(opendialog1.FileName);
                btPlotClick(Sender);
        end;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin

        if savedialog1.Execute then
        begin
                sample.SaveToFile(savedialog1.FileName);
        end;

end;

procedure TForm1.CopyData1Click(Sender: TObject);
var i : integer;
    s : string;
begin

        s := '';

        for i := 0 to sample.rowCount-1 do
        begin
                s := s + FloatToStrF(sample.getX(i), ffFixed, 16, 8) + chr(9) + FloatToStrF(sample.getY(i), ffFixed, 16, 8) + chr(13) + chr(10);
        end;

        clipboard.Clear;
        clipboard.AsText := s;

        ShowMessage('Test data copied.');
end;

procedure TForm1.CopyModel1Click(Sender: TObject);
begin
        memTest.CopyToClipboard;

        ShowMessage('Model copied.');
end;

procedure TForm1.CopyChart1Click(Sender: TObject);
begin

        chTest.CopyToClipboardMetafile(true);

        ShowMessage('Chart copied.');        
end;

procedure TForm1.PastData1Click(Sender: TObject);
var i, k, count : integer;
    s1 : TStringList;
    x, y : double;
begin
        s1 := TStringList.Create;
        s1.Delimiter := ';';

        s1.DelimitedText := Clipboard.AsText;

        if s1.DelimitedText <> '' then
        begin

            count := s1.Count div 2;
            sample.Resize(count);

            k := 0;
            for i := 0 to count-1 do
            begin
                    try
                            x := StrToFloat(s1.strings[k]);
                            y := StrToFloat(s1.strings[k+1]);
                    except
                            x := 0;
                            y := 0;
                    end;
                    sample.setX(i, x);
                    sample.setY(i, y);
                    k := k + 2;
            end;

            btPlotClick(Sender);

            ShowMessage('Test data pasted.');
        end;

        s1.Free;

end;

procedure TForm1.tb1Change(Sender: TObject);
begin

        tb1.Hint := IntToStr(tb1.Position)+'%';
        
end;

end.
